#ifndef ERRORS_H
#define ERRORS_H

#define ERRORMSG                    "\nAPISpy32 is unable to continue and will now terminate."

#define ERROR_GETWINDOWSVERSION     "An error occured while obtaining Windows version information."
#define ERROR_MAILSLOT              "An error occured while creating APISpy32_Mailslot."
#define ERROR_APISPY32DLL_NT        "An error occured while loading APISpyNT.dll."
#define ERROR_APISPY32DLL_9X        "An error occured while loading APISpy9x.dll."
#define ERROR_PSAPI                 "An error occured while initializing psapi.dll."
#define ERROR_TOOLHELP32            "An error occured while initializing toolhelp functions."
#define ERROR_LOGMUTEX              "An error occured while creating APISpy32_LogMutex."
#define ERROR_OVERFLOWEVENT         "An error occured while creating APISpy32_OverflowEvent."
#define ERROR_LOGEVENT              "An error occured while creating APISpy32_LogEvent."
#define ERROR_LOGTHREADEXITEVENT    "An error occured while creating LogThreadExitEvent."
#define ERROR_INJECTTHREADEXITEVENT "An error occured while creating InjectThreadExitEvent."
#define ERROR_LISTVIEWMUTEX         "An error occured while creating ListViewMutex."
#define ERROR_GETLOGPARAMETERS      "An error occured while obtaining address of GetLogParameters."
#define ERROR_ADVANCETONEXTLOGENTRY "An error occured while obtaining address of AdvanceToNextLogEntry."
#define ERROR_SETCAPTUREEVENTSFLAG  "An error occured while obtaining address of SetCaptureEventsFlag."
#define ERROR_SETAPISPY32PROCESSID  "An error occured while obtaining address of SetAPISpy32ProcessId."
#define ERROR_INJECTDLLTHREAD       "An error occured while creating the DLL injection thread."
#define ERROR_LOGTHREAD             "An error occured while creating the event logging thread."
#define ERROR_REGISTERCLASS         "An error occured during registration of the main window class."
#define ERROR_INITINSTANCE          "An error occured while creating main window."
#define ERROR_LISTVIEW              "An error occured while creating main list view control."

#define WARNING_ACCELERATORS        "An error occured while loading the keyboard accelerators.\nYou can still use APISpy32, but you will not be able to use keyboard shortcuts\nto access menu commands."
#define WARNING_TOOLBAR             "An error occured while creating the toolbar.\nYou can still use APISpy32, but you will need to access the main menu for issuing commands."
#define WARNING_DEBUGPRIVILEGE      "An error occured while obtaining debug privileges.\nAPISpy32 will not intercept API calls made by system processes."
#define WARNING_SHELLEXECUTE        "An error occured while loading help file."
#define WARNING_OPENLOGFILE         "An error occured while creating log file."

#endif
